;#########################
;#SETUPCARDS
;#Create and shuffle the Chance
;# and Community Chest card decks
;#input:hl = pointer of last byte in
;#      the deck
;#########################
setUpCards:
    ld b,16
    ld (hl),b               ;set up the chance deck, default values
    dec hl                  ; from top (chanceDeck+16) to bottom (chanceDeck+1)
    djnz $-2
    ld (hl),b               ;store the last value (chanceDeck)
    push hl                 ;hl=chance_cards
    pop ix                  ;ix=chance_cards
    dec hl
    ld b,16                 ;we have 16 cards, so shuffle all 16
sUC_shuffle:
    push bc
    push hl                 ;every hl should always = chanceDeck-1
    ld b,(255/17)+1         ;random number between 1-17
    call randomNumber       ;return random nuber in b
    ld b,0                  ;reset upper byte of bc
    add hl,bc               ;bc = the random number, so swap the
    ld b,(hl)               ; current card (ix) with another random
    ld c,(ix)               ; card (hl)
    ld (hl),c
    ld (ix),b
    inc ix                  ;go to the next card in the list
    pop hl
    pop bc                  ;our loop counter
    djnz sUC_shuffle
    ret

drawCard:
    ld a,(hl)               ;grab the first card from the deck
    ld e,l
    ld d,h
    inc hl                  ;ld de,hl, then inc hl
    ld bc,16
    ldir
    ld (de),a
    add a,a                 ;each text label is 2 bytes
    ld l,a
    ld h,0
    ld de,chance_cards
    add hl,de
    ld a,(hl)
    inc hl
    ld h,(hl)
    ld l,a
    ret
    
textChance: ;Chance
.db 2,26,19,27,21,23,$FF

textCommChest: ;Community Chest
.db 2,28,50,50,32,27,51,55,34,$FE,2,26,23,65,55,$FF

chance_cards:
.dw textC1
.dw textC2
.dw textC3
.dw textC3  ;there are two of these
.dw textC4
.dw textC5
.dw textC6
.dw textC7
.dw textC8
.dw textC9
.dw textC10
.dw textC11
.dw textC12
.dw textC13
.dw textC14
.dw textC15
.dw textC16

textC1: ;Advance to Go - Collect $200
.db 0,22,52,19,27,21,23,$FE,55,28,$FE,6,28,$FE,67,$FE,2,28,53,53,23,21,55,$FE,60,36,10,10,$FF
textC2: ;Advance to Illinois Ave - if you pass Go, collect $200
.db 0,22,52,19,27,21,23,$FE,55,28,$FE,45,53,53,51,27,28,51,65,$FE,0,52,23,$FE,67,$FE,51,24,$FE,34,28,32,$FE,29,19,65,65,$FE,6,28,63,$FE,21,28,53,53,23,21,55,$FE,60,36,10,10,$FF
textC3: ;Advance token to nearest Utility. If unowned, you may buy it from the Bank. If owned, throw dice and pay owner a total ten times the amount thrown.
.db 0,22,52,19,27,21,23,$FE,55,28,56,23,27,$FE,55,28,$FE,27,23,19,31,23,65,55,$FE,15,55,51,53,51,55,34,62,$FE,45,24,$FE,32,27,28,58,27,23,22,63,$FE,34,28,32,$FE,50,19,34,$FE,20,32,34,$FE,51,55,$FE,24,31,28,50,$FE,55,26,23,$FE,1,19,27,56,62,$FE,45,24,$FE,28,58,27,23,22,63,$FE,55,26,31,28,58,$FE,22,51,21,23,$FE,19,27,22,$FE,29,19,34,$FE,28,58,27,23,31,$FE,19,$FE,55,28,55,19,53,$FE,55,23,27,$FE,55,51,50,23,65,$FE,55,26,23,$FE,19,50,28,32,27,55,$FE,55,26,31,28,58,27,62,$FF
textC4: ;Advance token to the nearest Railroad and pay owner twice the rental to which they are otherwise entitled. If Railroad is unowned, you may buy it from the Bank.
.db 0,22,52,19,27,21,23,$FE,55,28,56,23,27,$FE,55,28,$FE,55,26,23,$FE,27,23,19,31,23,65,55,$FE,13,19,51,53,31,28,19,22,$FE,19,27,22,$FE,29,19,34,$FE,28,58,27,23,31,$FE,55,58,51,21,23,$FE,55,26,23,$FE,31,23,27,55,19,53,$FE,55,28,$FE,58,26,51,21,26,$FE,55,26,23,34,$FE,19,31,23,$FE,28,55,26,23,31,58,51,65,23,$FE,23,27,55,51,55,53,23,22,62,$FE,45,24,$FE,13,19,51,53,31,28,19,22,$FE,51,65,$FE,32,27,28,58,27,23,22,63,$FE,34,28,32,$FE,50,19,34,$FE,20,32,34,$FE,51,55,$FE,24,31,28,50,$FE,55,26,23,$FE,1,19,27,56,62,$FF
textC5: ;Advance to St. Charles Place - if you pass Go, collect $200
.db 0,22,52,19,27,21,23,$FE,55,28,$FE,14,55,62,$FE,2,26,19,31,53,23,65,$FE,11,53,19,21,23,$FE,67,$FE,51,24,$FE,34,28,32,$FE,29,19,65,65,$FE,6,28,63,$FE,21,28,53,53,23,21,55,$FE,60,36,10,10,$FF
textC6: ;Bank pays you dividend of $50
.db 1,19,27,56,$FE,29,19,34,65,$FE,34,28,32,$FE,22,51,52,51,22,23,27,22,$FE,28,24,$FE,60,39,10,$FF
textC7: ;Get out of Jail free - this card may be kept until needed, traded, or sold
.db 6,23,55,$FE,28,32,55,$FE,28,24,$FE,8,19,51,53,$FE,24,31,23,23,$FE,67,$FE,55,26,51,65,$FE,21,19,31,22,$FE,50,19,34,$FE,20,23,$FE,56,23,29,55,$FE,32,27,55,51,53,$FE,27,23,23,22,23,22,63,$FE,55,31,19,22,23,22,63,$FE,28,31,$FE,65,28,53,22,$FF
textC8: ;Go back 3 spaces
.db 6,28,$FE,20,19,21,56,$FE,37,$FE,65,29,19,21,23,65,$FF
textC9: ;Go directly to Jail - do not pass Go, do not collect $2OO
.db 6,28,$FE,22,51,31,23,21,55,53,34,$FE,55,28,$FE,8,19,51,53,$FE,67,$FE,22,28,$FE,27,28,55,$FE,29,19,65,65,$FE,6,28,63,$FE,22,28,$FE,27,28,55,$FE,21,28,53,53,23,21,55,$FE,60,36,10,10,$FF
textC10: ;Make general repairs on all your property - for each house pay $25 - for each hotel $1OO
.db 44,19,56,23,$FE,25,23,27,23,31,19,53,$FE,31,23,29,19,51,31,65,$FE,28,27,$FE,19,53,53,$FE,34,28,32,31,$FE,29,31,28,29,23,31,55,34,$FE,67,$FE,24,28,31,$FE,23,19,21,26,$FE,26,28,32,65,23,$FE,29,19,34,$FE,60,36,39,$FE,67,$FE,24,28,31,$FE,23,19,21,26,$FE,26,28,55,23,53,$FE,60,57,10,10,$FF
textC11: ;Pay poor tax of $15
.db 11,19,34,$FE,29,28,28,31,$FE,55,19,33,$FE,28,24,$FE,60,57,39,$FF
textC12: ;Take a trip to Reading Railroad - if you pass Go collect $2OO
.db 49,19,56,23,$FE,19,$FE,55,31,51,29,$FE,55,28,$FE,13,23,19,22,51,27,25,$FE,13,19,51,53,31,28,19,22,$FE,67,$FE,51,24,$FE,34,28,32,$FE,29,19,65,65,$FE,6,28,$FE,21,28,53,53,23,21,55,$FE,60,36,10,10,$FF
textC13: ;Take a walk on the Boardwalk - advance token to Boardwalk
.db 49,19,56,23,$FE,19,$FE,58,19,53,56,$FE,28,27,$FE,55,26,23,$FE,1,28,19,31,22,58,19,53,56,$FE,67,$FE,19,22,52,19,27,21,23,$FE,55,28,56,23,27,$FE,55,28,$FE,1,28,19,31,22,58,19,53,56,$FF
textC14: ;You have been elected chairman of the board - pay each player $5O
.db 17,28,32,$FE,26,19,52,23,$FE,20,23,23,27,$FE,23,53,23,21,55,23,22,$FE,21,26,19,51,31,50,19,27,$FE,28,24,$FE,55,26,23,$FE,20,28,19,31,22,$FE,67,$FE,29,19,34,$FE,23,19,21,26,$FE,29,53,19,34,23,31,$FE,60,39,10,$FF
textC15: ;Your building loan matures - collect $15O
.db 17,28,32,31,$FE,20,32,51,53,22,51,27,25,$FE,53,28,19,27,$FE,50,19,55,32,31,23,65,$FE,67,$FE,21,28,53,53,23,21,55,$FE,60,57,39,10,$FF
textC16: ;You have won a crossword competition - collect $1OO
.db 17,28,32,$FE,26,19,52,23,$FE,58,28,27,$FE,19,$FE,21,31,28,65,65,58,28,31,22,$FE,21,28,50,29,23,55,51,55,51,28,27,$FE,67,$FE,21,28,53,53,23,21,55,$FE,60,57,10,10,$FF

comm_chest_cards:
.dw textCC1
.dw textCC2
.dw textCC3
.dw textCC4
.dw textCC5
.dw textCC6
.dw textCC7
.dw textCC8
.dw textCC9
.dw textCC10
.dw textCC11
.dw textCC12
.dw textCC13
.dw textCC14
.dw textC1      ;advance to go
.dw textC7      ;get out of jail free
.dw textC9      ;go to jail

textCC1: ;Bank error in your favor - collect $75
.db 1,19,27,56,$FE,23,31,31,28,31,$FE,51,27,$FE,34,28,32,31,$FE,24,19,52,28,31,$FE,67,$FE,21,28,53,53,23,21,55,$FE,60,41,39,$FF
textCC2: ;Doctor's fees - Pay $5O
.db 3,28,21,55,28,31,68,65,$FE,24,23,23,65,$FE,67,$FE,11,19,34,$FE,60,39,10,$FF
textCC3: ;It is your birthday Collect $1O from each player
.db 45,55,$FE,51,65,$FE,34,28,32,31,$FE,20,51,31,55,26,22,19,34,62,$FE,2,28,53,53,23,21,55,$FE,60,57,10,$FE,24,31,28,50,$FE,23,19,21,26,$FE,29,53,19,34,23,31,$FF
textCC4: ;Grand Opera Night - collect $5O from every player for opening night seats
.db 6,31,19,27,22,$FE,10,29,23,31,19,$FE,54,51,25,26,55,$FE,67,$FE,21,28,53,53,23,21,55,$FE,60,39,10,$FE,24,31,28,50,$FE,23,52,23,31,34,$FE,29,53,19,34,23,31,$FE,24,28,31,$FE,28,29,23,27,51,27,25,$FE,27,51,25,26,55,$FE,65,23,19,55,65,$FF
textCC5: ;Income Tax refund - collect $2O
.db 45,27,21,28,50,23,$FE,49,19,33,$FE,31,23,24,32,27,22,$FE,67,$FE,21,28,53,53,23,21,55,$FE,60,36,10,$FF
textCC6: ;Life Insurance Matures - collect $1OO
.db 47,51,24,23,$FE,45,27,65,32,31,19,27,21,23,$FE,44,19,55,32,31,23,65,$FE,67,$FE,21,28,53,53,23,21,55,$FE,60,57,10,10,$FF
textCC7: ;Pay Hospital Fees of $1OO
.db 11,19,34,$FE,7,28,65,29,51,55,19,53,$FE,5,23,23,65,$FE,28,24,$FE,60,57,10,10,$FF
textCC8: ;Pay School Fees of $5O
.db 11,19,34,$FE,14,21,26,28,28,53,$FE,5,23,23,65,$FE,28,24,$FE,60,39,10,$FF
textCC9: ;Receive $25 Consultancy Fee
.db 13,23,21,23,51,52,23,$FE,60,36,39,$FE,2,28,27,65,32,53,55,19,27,21,34,$FE,5,23,23,$FF
textCC10: ;You are assessed for street repairs - $4O per house, $115 per hotel
.db 17,28,32,$FE,19,31,23,$FE,19,65,65,23,65,65,23,22,$FE,24,28,31,$FE,65,55,31,23,23,55,$FE,31,23,29,19,51,31,65,$FE,67,$FE,60,38,10,$FE,29,23,31,$FE,26,28,32,65,23,63,$FE,60,57,57,39,$FE,29,23,31,$FE,26,28,55,23,53,$FF
textCC11: ;You have won second prize in a beauty contest - collect $1O
.db 17,28,32,$FE,26,19,52,23,$FE,58,28,27,$FE,65,23,21,28,27,22,$FE,29,31,51,35,23,$FE,51,27,$FE,19,$FE,20,23,19,32,55,34,$FE,21,28,27,55,23,65,55,$FE,67,$FE,21,28,53,53,23,21,55,$FE,60,57,10,$FF
textCC12: ;You inherit $1OO
.db 17,28,32,$FE,51,27,26,23,31,51,55,$FE,60,57,10,10,$FF
textCC13: ;From sale of stock you get $5O
.db 5,31,28,50,$FE,65,19,53,23,$FE,28,24,$FE,65,55,28,21,56,$FE,34,28,32,$FE,25,23,55,$FE,60,39,10,$FF
textCC14: ;Holiday Fund matures - Receive $1OO
.db 7,28,53,51,22,19,34,$FE,5,32,27,22,$FE,50,19,55,32,31,23,65,$FE,67,$FE,13,23,21,23,51,52,23,$FE,60,57,10,10,$FF